%define anolis_release 2
%bcond_with tests

%global srcname setuptools
%global python_wheel_name %{srcname}-%{version}-py3-none-any.whl

Name:           python-setuptools
Version:        68.0.0
Release:        %{anolis_release}%{?dist}
Summary:        Easily build and distribute Python packages

License:        MIT and ASL 2.0 and (BSD or ASL 2.0) and Python
URL:            https://pypi.python.org/pypi/%{srcname}
Source0:        %{pypi_source %{srcname} %{version}}

BuildArch:       noarch
BuildRequires:   python3-devel
BuildRequires:   pyproject-rpm-macros >= 0-44
BuildRequires:   python%{python3_pkgversion}-setuptools
BuildRequires:   python3-rpm-generators >= 11-8
%if %{with tests}
BuildRequires:   gcc
BuildRequires:   python%{python3_pkgversion}-pytest
%endif

%description
Setuptools is a collection of enhancements to the Python distutils that allow
you to more easily build and distribute Python packages, especially ones that
have dependencies on other packages.

This package also contains the runtime components of setuptools, necessary to
execute the software that requires pkg_resources.


%global bundled %{expand:
Provides: bundled(python%{python3_pkgversion}dist(appdirs)) = 1.4.3
Provides: bundled(python%{python3_pkgversion}dist(importlib-metadata)) = 4.11.1
Provides: bundled(python%{python3_pkgversion}dist(importlib-resources)) = 5.4
Provides: bundled(python%{python3_pkgversion}dist(jaraco-text)) = 3.7
Provides: bundled(python%{python3_pkgversion}dist(more-itertools)) = 8.8
Provides: bundled(python%{python3_pkgversion}dist(ordered-set)) = 3.1.1
Provides: bundled(python%{python3_pkgversion}dist(packaging)) = 21.3
Provides: bundled(python%{python3_pkgversion}dist(pyparsing)) = 2.2.1
Provides: bundled(python%{python3_pkgversion}dist(typing-extensions)) = 4.0.1
Provides: bundled(python%{python3_pkgversion}dist(zipp)) = 3.7
}

%package -n python%{python3_pkgversion}-setuptools
Summary:        Easily build and distribute Python 3 packages
%{bundled}

%py_provides    python%{python3_pkgversion}-pkg_resources
%py_provides    python%{python3_pkgversion}-pkg-resources

%description -n python%{python3_pkgversion}-setuptools
Setuptools is a collection of enhancements to the Python 3 distutils that allow
you to more easily build and distribute Python 3 packages, especially ones that
have dependencies on other packages.

This package also contains the runtime components of setuptools, necessary to
execute the software that requires pkg_resources.

%package -n     %{python_wheel_pkg_prefix}-%{srcname}-wheel
Summary:        The setuptools wheel
%{bundled}

%description -n %{python_wheel_pkg_prefix}-%{srcname}-wheel
A Python wheel of setuptools to use with venv.

%package -n     python%{python3_pkgversion}-setuptools-doc
Summary:        doc files for python%{python3_pkgversion}-setuptools
Requires:       python%{python3_pkgversion}-setuptools = %{version}-%{release}

%description -n python%{python3_pkgversion}-setuptools-doc
doc files for python%{python3_pkgversion}-setuptools.

%prep
%autosetup -p1 -n %{srcname}-%{version}

find setuptools pkg_resources -name \*.py | xargs sed -i -e '1 {/^#!\//d}'
rm -f setuptools/*.exe
rm -r docs/conf.py

%generate_buildrequires
%pyproject_buildrequires -r %{?with_tests:-x testing}

%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files setuptools pkg_resources _distutils_hack

rm -rf %{buildroot}%{python3_sitelib}/pkg_resources/tests/
sed -i '/\/pkg_resources\/tests\b/d' %{pyproject_files}

mkdir -p %{buildroot}%{python_wheel_dir}
install -p %{_pyproject_wheeldir}/%{python_wheel_name} -t %{buildroot}%{python_wheel_dir}

%if %{with tests}
%check
cat pkg_resources/_vendor/vendored.txt setuptools/_vendor/vendored.txt > allvendor.txt
%{_rpmconfigdir}/pythonbundles.py allvendor.txt --namespace 'python%{python3_pkgversion}dist' --compare-with '%{bundled}'

test $(du %{_pyproject_wheeldir}/%{python_wheel_name} | cut -f1) -lt 800

test ! -d %{buildroot}%{python3_sitelib}/pkg_resources/tests
test ! -d %{buildroot}%{python3_sitelib}/setuptools/tests

rm pyproject.toml

PRE_BUILT_SETUPTOOLS_WHEEL=%{_pyproject_wheeldir}/%{python_wheel_name} \
PYTHONPATH=$(pwd) %pytest \
 --ignore=setuptools/tests/test_integration.py \
 --ignore=setuptools/tests/integration/ \
 --ignore=setuptools/tests/test_develop.py \
 -k "not test_pip_upgrade_from_source"
%endif

%files -n python%{python3_pkgversion}-setuptools %{?!with_bootstrap:-f %{pyproject_files}}
%license LICENSE
%doc docs/*
%{python3_sitelib}/distutils-precedence.pth

%files -n %{python_wheel_pkg_prefix}-%{srcname}-wheel
%license LICENSE
# we own the dir for simplicity
%dir %{python_wheel_dir}/
%{python_wheel_dir}/%{python_wheel_name}

%files -n python%{python3_pkgversion}-setuptools-doc
%doc CHANGES.rst README.rst

%changelog
* Mon Mar 11 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 68.0.0-2
- Rebuild with python3.11

* Tue Mar  5 2024 Liwei Ge <liwei.glw@alibaba-inc.com> - 68.0.0-1
- Update to 68.0.0

* Tue Apr 11 2023 Funda Wang <fundawang@yeah.net> - 65.5.1-2
- link C module with libpython

* Thu Feb 16 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 65.5.1-1
- update to version 65.5.1

* Wed Mar 16 2022 forrest_ly <flin@linux.alibaba.com> - 60.9.3-1
- Init for Anolis OS 23
